Summary: The Berkeley Database Information Index version 4 (BDIIv4)
Name: bdii4
Version: 4.0.2.2
Vendor: LCG
Release: 2ng%{?dist}
License: ASL 2.0
Group: System Environment/Daemons
Source: %{name}-%{version}.tar.gz
# Change bdii file locations to standard values
Patch0: bdii.patch
# Add option to turn the bdii self-monitoring service on/off
Patch1: bdii-update.patch
# Allow standard location for BDII_DIR (/usr)
Patch2: bdii-dir.patch
# Allow default configuration to work on all BDB versions out-of-the-box
Patch3: bdii-bdb.patch
Url: https://twiki.cern.ch/twiki/bin/view/EGEE/BDIIv4
BuildArch: noarch
%if 0%{?suse_version} > 0
Requires: openldap2-client
Requires: openldap2
%else
Requires: openldap-clients
Requires: openldap-servers
%endif
Requires: perl-libwww-perl
BuildRoot: %{_tmppath}/%{name}-%{version}-build

%description
The Berkeley Database Information Index version 4 (BDIIv4).

%prep
%setup -q
%patch0 -p0
%patch1 -p0
%patch2 -p0
%patch3 -p0

%build
pod2man -s 5 --center "BDII Configuration" doc/section5 > doc/bdii4.5
pod2man -s 8 --center "BDII Services"      doc/section8 > doc/bdii4.8
chmod -x README
sed -i 's/^set_flags DB_TXN_NOT_DURABLE/\n# Use this flag for BDB < 4.3\n# &\n#\n# Use these flags for BDB >= 4.3 (true for CentOS 5)\n# set_flags DB_LOG_INMEMORY\n# set_lg_bsize 20485760\n/' etc/DB_CONFIG

%install
rm -rf $RPM_BUILD_ROOT

mkdir -p ${RPM_BUILD_ROOT}%{_sbindir}/
mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/bdii4/
mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d/
mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/init.d/
mkdir -p ${RPM_BUILD_ROOT}%{_mandir}/man5/
mkdir -p ${RPM_BUILD_ROOT}%{_mandir}/man8/
mkdir -p ${RPM_BUILD_ROOT}%{_localstatedir}/log/bdii4/
mkdir -p ${RPM_BUILD_ROOT}%{_localstatedir}/lib/bdii4/
mkdir -p ${RPM_BUILD_ROOT}%{_localstatedir}/run/bdii4/

install -m 0755 sbin/bdii-fwd         ${RPM_BUILD_ROOT}/%{_sbindir}/bdii4-fwd
install -m 0755 sbin/bdii-proxy       ${RPM_BUILD_ROOT}/%{_sbindir}/bdii4-proxy
install -m 0755 sbin/bdii-update      ${RPM_BUILD_ROOT}/%{_sbindir}/bdii4-update 
install -m 0755 etc/init.d/bdii       ${RPM_BUILD_ROOT}/%{_sysconfdir}/init.d/bdii4
install -m 0644 etc/logrotate.d/bdii  ${RPM_BUILD_ROOT}/%{_sysconfdir}/logrotate.d/bdii4
install -m 0644 etc/bdii.conf         ${RPM_BUILD_ROOT}/%{_sysconfdir}/bdii4/
install -m 0644 etc/bdii-update.conf  ${RPM_BUILD_ROOT}/%{_sysconfdir}/bdii4/
install -m 0644 etc/glue-slapd.conf   ${RPM_BUILD_ROOT}/%{_sysconfdir}/bdii4/
install -m 0644 etc/DB_CONFIG         ${RPM_BUILD_ROOT}/%{_sysconfdir}/bdii4/
install -m 0644 etc/default.ldif      ${RPM_BUILD_ROOT}/%{_sysconfdir}/bdii4/
install -m 0644 etc/BDII.schema       ${RPM_BUILD_ROOT}/%{_sysconfdir}/bdii4/

install -m 0644 doc/bdii4.5 ${RPM_BUILD_ROOT}/%{_mandir}/man5/bdii4.5
install -m 0644 doc/bdii4.8 ${RPM_BUILD_ROOT}/%{_mandir}/man8/bdii4.8

%post
/sbin/chkconfig --add bdii4

%preun
if [ $1 = 0 ]; then
  service bdii4 stop > /dev/null 2>&1
  /sbin/chkconfig --del bdii4
fi

%postun
if [ "$1" -ge "1" ]; then
  service bdii4 condrestart > /dev/null 2>&1
fi
exit 0

%files
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/bdii4/bdii.conf
%config(noreplace) %{_sysconfdir}/bdii4/bdii-update.conf
%config(noreplace) %{_sysconfdir}/bdii4/glue-slapd.conf
%config(noreplace) %{_sysconfdir}/bdii4/BDII.schema
%config(noreplace) %{_sysconfdir}/bdii4/DB_CONFIG
%config(noreplace) %{_sysconfdir}/bdii4/default.ldif
%config(noreplace) %{_sysconfdir}/logrotate.d/bdii4
%doc README
%{_mandir}/man5/bdii4.5*
%{_mandir}/man8/bdii4.8*
%{_sysconfdir}/init.d/bdii4
%{_sbindir}/bdii4-fwd
%{_sbindir}/bdii4-proxy
%{_sbindir}/bdii4-update
%dir %{_localstatedir}/log/bdii4
%dir %{_localstatedir}/lib/bdii4
%dir %{_localstatedir}/run/bdii4

%clean
rm -rf %{buildroot}

%changelog
* Sat Sep 19 2009 Anders Waananen <waananen@nbi.dk> - 4.0.2.2-2ng
- Update bdii.patch with missing rename in bdii-update

* Wed Aug 12 2009 Anders Waananen <waananen@nbi.dk> - 4.0.2.2-1ng
- Change name from bdii to bdii4 and update bdii.patch accordingly

* Wed Aug 12 2009 Anders Waananen <waananen@nbi.dk> - 4.0.2-4ng
- Make DB_CONFIG BDB version independent (must be updated to be optimal)
- Add /var/run/bdii to the package
- Add bdii-dir.patch to allow standard locations 
- Add bdii-bdb.patch to make it work on all BDB versions out-of-the-box

* Thu Jul 16 2009 Anders Waananen <waananen@nbi.dk> - 4.0.2-3ng
- Specfile rewritten to be more standard compliant

